// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Dock;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockManager")]
    pub struct DockManager(Object<ffi::DzlDockManager, ffi::DzlDockManagerClass>);

    match fn {
        type_ => || ffi::dzl_dock_manager_get_type(),
    }
}

impl DockManager {
    pub const NONE: Option<&'static DockManager> = None;

    #[doc(alias = "dzl_dock_manager_new")]
    pub fn new() -> DockManager {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_dock_manager_new()) }
    }
}

impl Default for DockManager {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockManager>> Sealed for T {}
}

pub trait DockManagerExt: IsA<DockManager> + sealed::Sealed + 'static {
    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_dock_manager_pause_grabs")]
    fn pause_grabs(&self) {
        unsafe {
            ffi::dzl_dock_manager_pause_grabs(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_dock_manager_register_dock")]
    fn register_dock(&self, dock: &impl IsA<Dock>) {
        unsafe {
            ffi::dzl_dock_manager_register_dock(
                self.as_ref().to_glib_none().0,
                dock.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_dock_manager_release_transient_grab")]
    fn release_transient_grab(&self) {
        unsafe {
            ffi::dzl_dock_manager_release_transient_grab(self.as_ref().to_glib_none().0);
        }
    }

    #[cfg(feature = "v3_26")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_26")))]
    #[doc(alias = "dzl_dock_manager_unpause_grabs")]
    fn unpause_grabs(&self) {
        unsafe {
            ffi::dzl_dock_manager_unpause_grabs(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_dock_manager_unregister_dock")]
    fn unregister_dock(&self, dock: &impl IsA<Dock>) {
        unsafe {
            ffi::dzl_dock_manager_unregister_dock(
                self.as_ref().to_glib_none().0,
                dock.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "register-dock")]
    fn connect_register_dock<F: Fn(&Self, &Dock) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn register_dock_trampoline<
            P: IsA<DockManager>,
            F: Fn(&P, &Dock) + 'static,
        >(
            this: *mut ffi::DzlDockManager,
            object: *mut ffi::DzlDock,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                DockManager::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"register-dock\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    register_dock_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "unregister-dock")]
    fn connect_unregister_dock<F: Fn(&Self, &Dock) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn unregister_dock_trampoline<
            P: IsA<DockManager>,
            F: Fn(&P, &Dock) + 'static,
        >(
            this: *mut ffi::DzlDockManager,
            object: *mut ffi::DzlDock,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                DockManager::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"unregister-dock\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    unregister_dock_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockManager>> DockManagerExt for O {}

impl fmt::Display for DockManager {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockManager")
    }
}
